local LibExoY = LibExoYsUtilities
local LAM = LibAddonMenu2
local EM = GetEventManager()


local function OnAddonLoaded(_, addonName)

  if addonName == "ExoYsAchievementAnonymizer" then
    EM:UnregisterForEvent("ExoYsAchievementAnonymizer", EVENT_ADD_ON_LOADED)

    local defaults = {
      useCustom = false,
      string = "Custom Text",
      color = {1,1,1,1},
    }

    local store = ZO_SavedVars:NewAccountWide("ExoYsAchievementAnonymizerSV", 2, nil, defaults)

    local function Update()
      local string = ""
      if store.useCustom then
        string = LibExoY.ColorString(store.string, store.color)
      end

      SafeAddString(SI_ACHIEVEMENT_EARNED_FORMATTER, string, 2)

    end

    -- Creating Menu
    local panelData = {
      type = "panel",
      name = "|c00FF00ExoY|rs Achievement Anonymizer",
      displayName = "|c00FF00ExoY|rs Achievement Anonymizer",
      author = "@|c00FF00ExoY|r94 (PC/EU)",
      version = "2.0",
      }

    local optionsData = {
      LibExoY.FeedbackSubmenu("ExoYs Achievement Anonymizer", "info3328-ExoYsAchievementAnonymizer.html"),
        {
          type = "checkbox",
          name = "Enable custom text:",
          tooltip = "Displays a custom text, instead of just hiding the character name.",
          getFunc = function() return store.useCustom end,
          setFunc = function( value )
            store.useCustom = value
            Update()
          end,
          width = "full",
        },
        {type = "editbox",
        name = "",
        getFunc = function() return store.string end,
        setFunc = function( text )
            store.string = text
            Update()
         end,
        isMultiline = false,
        width = "half",
      },
      {
        type = "colorpicker",
        tooltip = "Changes color of custom text.",
        name = "",
        getFunc = function() return unpack( store.color ) end,
        setFunc = function(r,g,b)
          store.color = {r,g,b,1}
          Update()
        end,
        width = "half",
      },
    }

    LAM:RegisterAddonPanel("EAA_Settings", panelData)
    LAM:RegisterOptionControls("EAA_Settings", optionsData)

    Update()
    ZO_PreHook(Achievement, "RefreshTooltip", function()
      return true
    end)

  end
  
end

EM:RegisterForEvent("ExoYsAchievementAnonymizer", EVENT_ADD_ON_LOADED, OnAddonLoaded)
